const node_nudb = require('./lib');

const argv = require('yargs').usage('Usage: $0 [options]')
    .alias('h', 'host')
    .describe('h', 'Host')
    .alias('p', 'port')
    .describe('p', 'Port')
    .alias('d', 'db')
    .describe('d', 'DB name')
    .demandOption(['host', 'port', 'db'])
    .help('H')
    .alias('H', 'help')
    .argv;

const main = async () => {
    const nudb = new node_nudb.Nudb();
    //nudb.connect('localhost', 5800, 'test');
    nudb.connect(argv.host, argv.port, argv.db);

    try {
        /*const dbInfo = await nudb.getDBInfo();            // error
        console.log('dbInfo :', dbInfo);*/
        /*const dbInfo2 = await nudb.getDBInfo(argv.db);    // ok
        console.log('dbInfo2 :', dbInfo2);*/

        /*const search1 = await nudb.search({});            // error
        console.log('search1 :', search1);*/
        /*const search2 = await nudb.search({
            db: argv.db,
            q: '',
            out: 'json'
        });     // ok
        console.log('search2 :', search2);
        console.log('---');*/

        /*const rget1 = await nudb.rget();      // error
        console.log('rget1', rget1);*/
        /*const rget2 = await nudb.rget(5);     // ok
        console.log('rget2', rget2);
        console.log('---');*/

        /*const rput = await nudb.rput();       // error
        console.log('rput', rput);*/

        /*const rput2 = await nudb.rput({test: 'test'});            // error
        console.log('rput2', rput2);*/

        /*const rput3 = await nudb.rput({test: 'test'}, 'text');    // error
        console.log('rput3', rput3);*/

        /*const rput4 = await nudb.rput({test: 'test'}, 'json');    // ok
        console.log('rput4', rput4);*/

        /*const rput5 = await nudb.rput('@test:123', 'text');       // ok
        console.log('rput5', rput5);*/

        /*const rput6 = await nudb.rput('{data:test', 'json');      // error
        console.log('rput6', rput6);*/

        /*const fput = await nudb.fput();                           // error
        console.log('fput:', fput);*/

        /*const fput2 = await nudb.fput('../test_node_nudb/test_gais.txt'); // error
        console.log('fput2:', fput2);*/
        
        /*const fput3 = await nudb.fput('../test_node_nudb/test_json.json', 'json');    // ok
        console.log('fput3:', fput3);*/

        /*const fput4 = await nudb.fput('../test_node_nudb/test_gais.txt', 'text'); // error
        console.log('fput4:', fput4);*/

        /*const fput5 = await nudb.fput('../test_node_nudb/test_gais.txt', 'text', '@Gais_REC:');   // ok
        console.log('fput5:', fput5);*/

        //console.log(await nudb.rdel());   // error
        //console.log(await nudb.rdel(5));  // ok

        //console.log(await nudb.rupdate());                            // error
        //console.log(await nudb.rupdate(11));                          // error
        //console.log(await nudb.rupdate(11, {data: 'test2'}, 'text')); // error
        //console.log(await nudb.rupdate(11, '@data:test3'));           // error
        //console.log(await nudb.rupdate(11, '{data:1234', 'json'));    // error
        //console.log(await nudb.rupdate(11, '@data:test3', 'text', 'aaa'));  // error
        //console.log(await nudb.rupdate(11, '@data:test3', 'text'));   // ok
        //console.log(await nudb.rupdate(17, '@abc:test4', 'text', 'rid', 'replaceRecord'));    // ok
        //console.log(await nudb.rupdate(18, '@data:test5', 'text', 'rid', 'replaceField'));    // ok

        //console.log(await nudb.rget('305bc9e6f9c1d5bdd2995b25401122b3', 'primary key'));  // error
        //console.log(await nudb.rget(19, 'rid'));  // ok
        //console.log(await nudb.rget('305bc9e6f9c1d5bdd2995b25401122b3', 'key'));  // ok

        //console.log(await nudb.rupdate('305bc9e6f9c1d5bdd2995b25401122b3', {testField: 'test1'}, 'json', 'primary key', 'replaceField'));   // error
        //console.log(await nudb.rupdate('305bc9e6f9c1d5bdd2995b25401122b3', {testField: 'test2'}, 'json', 'key', 'replaceField')); // ok
        //console.log(await nudb.rupdate(20, {testField: 'test3'}, 'json', 'rid', 'replaceField')); // ok
        //console.log(await nudb.rupdate(21, '@testField:test4', 'json', 'rid', 'replaceField'));     // error
        //console.log(await nudb.rupdate(21, '@testField:test5', 'text', 'rid', 'replaceField'));  // ok
        //console.log(await nudb.rupdate(22, '@testField:test6', 'json', 'rid', 'replaceRecord')); // error

    } catch(err) {
        console.log(err);
    }
};

main();